﻿using Stimulsoft.Base.Localization;
using Stimulsoft.Helper.RT.Localization;
using Stimulsoft.Report;
using Stimulsoft.Report.Export;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.Storage;
using Windows.System;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using System.Threading;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace TesteStimulsoftReports
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
            this.Loaded += MainPage_Loaded;
        }

        async void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            StiOptions.Viewer.Elements.MainToolBarVisibility = Visibility.Collapsed;
            StiOptions.Viewer.Elements.BookmarksPanelVisibility = Visibility.Collapsed;
            StiOptions.Viewer.Elements.PageDeleteButtonVisibility = Visibility.Collapsed;
            StiOptions.Viewer.Elements.PageFirstButtonVisibility = Visibility.Collapsed;
            StiOptions.Viewer.Elements.PageGoToButtonVisibility = Visibility.Collapsed;
            StiOptions.Viewer.Elements.PageLastButtonVisibility = Visibility.Collapsed;
            StiOptions.Viewer.Elements.PageNewButtonVisibility = Visibility.Collapsed;
            StiOptions.Viewer.Elements.PageNextButtonVisibility = Visibility.Collapsed;
            StiOptions.Viewer.Elements.PagePreviousButtonVisibility = Visibility.Collapsed;
            StiOptions.Viewer.Elements.PageSizeButtonVisibility = Visibility.Collapsed;
            StiOptions.Viewer.Elements.ReportExportButtonVisibility = Visibility.Collapsed;
            StiOptions.Viewer.Elements.ReportOpenButtonVisibility = Visibility.Collapsed;
            StiOptions.Viewer.Elements.ReportPrintButtonVisibility = Visibility.Collapsed;
            StiOptions.Viewer.Elements.ReportSaveButtonVisibility = Visibility.Collapsed;
            StiOptions.Viewer.Elements.ToolEditorButtonVisibility = Visibility.Collapsed;
            StiOptions.Viewer.Elements.ToolFindButtonVisibility = Visibility.Collapsed;
             

           

            reportViewer.ToolbarPanel.Visibility = Visibility.Collapsed;

           
            
            
            LoadReport();
        }

       


        private async void GetReport()
        { 
            StiReport report = new StiReport();
            var picker = new Windows.Storage.Pickers.FileOpenPicker();
            picker.FileTypeFilter.Add(".mrt");
            picker.SuggestedStartLocation = Windows.Storage.Pickers.PickerLocationId.ComputerFolder;
            StorageFile storageFile = storageFile = await picker.PickSingleFileAsync();

            if (storageFile != null)
            {
                await report.LoadAsync(storageFile);
                report.RegBusinessObject("People", "People", GetData());
                
                await report.RenderAsync();
                reportViewer.Report = report;
            }
        }

        private async void SendToPDF()
        {
                            
                //export to PDF
                StiPdfExportService exportPDFService = new StiPdfExportService();
                var pickerPDF = new Windows.Storage.Pickers.FileSavePicker();
                pickerPDF.FileTypeChoices.Add("Files report (*.pdf)", new List<string>() { ".pdf" });
                pickerPDF.SuggestedStartLocation = Windows.Storage.Pickers.PickerLocationId.ComputerFolder;
                pickerPDF.SuggestedFileName = "Report1PDF";
                var storageFilePDF = await pickerPDF.PickSaveFileAsync();
                if (storageFilePDF != null)
                {

                    await exportPDFService.ExportPdfAsync(reportViewer.Report, storageFilePDF, new StiPdfExportSettings());
                    await Launcher.LaunchFileAsync(storageFilePDF);
                }

            
            
        }

        private async void RegisterTemplate()
        {
                      
            //used to get data structure so we can use it in report
            var picker = new Windows.Storage.Pickers.FileSavePicker();
            picker.FileTypeChoices.Add("Files report (*.mrt)", new List<string>() { ".mrt" });
            picker.SuggestedFileName = "Report1";
            picker.SuggestedStartLocation = Windows.Storage.Pickers.PickerLocationId.ComputerFolder;
            var storageFile = await picker.PickSaveFileAsync();
            if (storageFile != null)
            {
                StiReport report = new StiReport();
                report.RegBusinessObject("People", "People", GetData());
                report.Dictionary.SynchronizeBusinessObjects(3);
                await report.SaveAsync(storageFile);
            }
        }


        private object GetData()
        {
            return new Person();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            RegisterTemplate();
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            GetReport();
        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            SendToPDF();
        }

        private async void LoadReport()
        {
            StiReport report = new StiReport();
            //var picker = new Windows.Storage.Pickers.FileOpenPicker();
            //picker.FileTypeFilter.Add(".mrt");
            //picker.SuggestedStartLocation = Windows.Storage.Pickers.PickerLocationId.ComputerFolder;
            //StorageFile storageFile = storageFile = await picker.PickSingleFileAsync();
            StorageFile storageFile = await Windows.ApplicationModel.Package.Current.InstalledLocation.GetFileAsync("Report1.mrt");
            if (storageFile != null)
            {
                await report.LoadAsync(storageFile);
                report.RegBusinessObject("People", "People", GetData());

                await report.RenderAsync();
                reportViewer.Report = report;
            }
        }
    }
}
